package DB_XML;

import java.io.IOException;

import Interface_XWeb.Xwebapp;

import ru.ispras.sedna.driver.*;

/**
 * Classe herite de la Classe Abstrait DataBase,permet de gerer la connection
 * avec une base de donnes Sedna
 * 
 */
public class Sedna extends DataBase
{

	SednaConnection con;

	public Sedna()
	{
		super();
		con = null;
	}

	private SednaConnection connect()
	{
		try
		{
			con = DatabaseManager.getConnection(host, dbName, user, pass);

		} catch (DriverException e)
		{
			System.out.println(e.toString());
		}
		return con;
	}

	public boolean connection()
	{
		boolean b = true;
		con = connect();
		try
		{
			SednaStatement st1 = con.createStatement();

		} catch (Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			b = false;
		}
		return b;
	}

	public boolean connection(String _host, String _dbName, String _user,
			String _pass)
	{
		host = _host;
		dbName = _dbName;
		user = _user;
		pass = _pass;
		return connection();
	}

	public boolean deconnection()
	{

		try
		{
			con.close();
		} catch (DriverException de)
		{
			de.printStackTrace();
			return false;
		}
		return true;
	}

	public long addFile(String file, String doc_name)
	{

		try
		{
			long t1;
			long t2;
			t1 = System.currentTimeMillis();
			con.begin();
			SednaStatement st1 = con.createStatement();
			System.out.println("Loading data");
            
			boolean call_res = st1.execute("LOAD \"" + file + "\" \""
					+ doc_name + "\"");
			if (!call_res)
			{
				System.out.println("Load succeeded");
				System.out.println("=====================================\n");
			}
			con.commit();
			t2 = System.currentTimeMillis();
			return t2-t1;
		} catch (DriverException e)
		{
			System.out.println(e.toString());
			return -1;
		}
	}

	public long executeReq(String req)
	{
		long l1;
		long l2;
		l1 = System.currentTimeMillis();
		String item;
		int count;
		System.out.println("Executing query");

		try
		{
			SednaConnection con = connect();
			con.begin();

			SednaStatement st1 = con.createStatement();

			
			boolean call_res = st1.execute(req);
			
			
			if (call_res)
			{
				System.out.println("Result:");
				SednaSerializedResult pr1 = st1.getSerializedResult();
				item = null;
				item = pr1.next();
				count = 1;
				while (item != null)
				{
					//System.out.println(count + " item: " + item);
					item = pr1.next();
					//System.out.println("=====================================\n");
					count++;
				}
			}
			
			l2 = System.currentTimeMillis();
			con.commit();
			con.close();
	
			return l2 - l1;
		} catch (DriverException e)
		{
			e.printStackTrace();
			System.out.println(e.toString());
			return -1;
		}

	}

	public static void main(String args[])
	{
		Sedna sedna = new Sedna();
		sedna.connection("localhost", "testdb", "SYSTEM", "MANAGER");
		// sedna.executeReq("//dimensions");
		// connect();
		// sedna.addFile("warehouse/dimension_Suppliers.xml","Faits");
		// query("for $x in document(\"students.xml\")//etudiant return $x");
		// sedna.addFile("E:/Workspace/XWeb_Final/warehouse/dimension_Customers.xml",
		// "dimension_Customers.xml");
		sedna.executeReq("//Level");
		// sedna.addFile("warehouse/dimension_Suppliers.xml","Faits");
		// System.out.println(sedna.deconnection());
	}
}