package DB_XML;

import java.io.File;

import javax.xml.transform.OutputKeys;

import org.xmldb.api.base.*;
import org.xmldb.api.modules.*;
import org.xmldb.api.*;

/**
 * Classe herite de la Classe Abstrait DataBase,permet de gerer la connection
 * avec une base de donnees Exist
 * 
 */
public class eXist extends DataBase
{
	private String driver = "org.exist.xmldb.DatabaseImpl";
	private Database db;

	public eXist(){
		super();
	}

	public boolean connection()	{
		boolean res=false;
		try
		{
			// initialise le driver
			Class cl = Class.forName(driver);
			db = (Database) cl.newInstance();
			DatabaseManager.registerDatabase(db);
			// connection à la collection
			Collection col = DatabaseManager.getCollection(host + "/" + dbName);
			if (col == null)
				res=false;
			res=true;
		} catch (Exception e){
			System.out.println(e.getMessage());
			e.printStackTrace();
			res=false;
		}
		return res;
	}

	public boolean deconnection()
	{
		boolean res = false;
		try
		{
			DatabaseManager.deregisterDatabase(db);
			res = true;
		} catch (Exception e)
		{
			System.out.println(e.getMessage());
		}
		return res;
	}

	public long addFile(String path, String resName)
	{
		try
		{
			long t1;
			long t2;
			t1 = System.currentTimeMillis();
			// initialise le driver
			Class cl = Class.forName(driver);
			Database database = (Database) cl.newInstance();
			DatabaseManager.registerDatabase(database);
			// connection à la collection
			Collection col = DatabaseManager.getCollection(host + "/" + dbName);
			if (col == null)
				return -1;
			XMLResource document = (XMLResource) col.createResource(resName,
					"XMLResource");
			// Lecture du fichier
			File f = new File(path);
			if (!f.canRead())
			{
				System.out.println("cannot read file " + f.getName());
				return -1;
			}
			document.setContent(f);
			System.out.println("Load succeeded for file "+f.getName());
			System.out.println("=====================================\n");
			// Insertion du fichier dans la base
			col.storeResource(document);
            t2 = System.currentTimeMillis();
			return t2-t1;
		} catch (Exception e)
		{
			System.out.println(e.getMessage());
			return -1;
		}
	}

	public long executeReq(String Req)
	{
		Collection col = null;
		try
		{
			long t1;
			long t2;
			// initialise le driver
			Class cl = Class.forName(driver);
			Database database = (Database) cl.newInstance();
			DatabaseManager.registerDatabase(database);
			// Connection  la collection
			col = DatabaseManager.getCollection(host + "/" + dbName, user, pass);
			if (col == null) return -1;

			col.setProperty(OutputKeys.INDENT, "no");
			XPathQueryService service = (XPathQueryService) col.getService("XPathQueryService", "1.0");
			service.setProperty("indent", "yes");
			// Execution de la requete
			t1 = System.currentTimeMillis();
			ResourceSet result = service.query(Req);
			t2 = System.currentTimeMillis();
			// Affichage du rsultat
			
			ResourceIterator it = result.getIterator(); 
			while(it.hasMoreResources()) { 
				 Resource r = it.nextResource();
				 //System.out.println((String) r.getContent()); 
			}
			 
			return t2 - t1;
		} catch (Exception e)
		{
			System.out.println(e.getMessage());
			return -1;
		} finally
		{
			if (col != null)
			{
				try
				{
					col.close();
				} catch (XMLDBException e)
				{
					System.out.println(e.getMessage());
				}
			}
		}

	}
}
