package DB_XML;

import com.xhive.XhiveDriverFactory;
import com.xhive.core.interfaces.XhiveDatabaseIf;
import com.xhive.core.interfaces.XhiveDriverIf;
import com.xhive.core.interfaces.XhiveSessionIf;
import com.xhive.dom.interfaces.XhiveLibraryIf;
import com.xhive.query.interfaces.XhiveXQueryValueIf;
import com.xhive.util.interfaces.IterableIterator;


public final class test {

  private test() {
    // Should not be instantiated
  }

  public static void main(String[] args) {

    // create a session 
    XhiveDriverIf driver = XhiveDriverFactory.getDriver("xhive://localhost:1235");
    driver.init(1024);
    //driver.init();
    XhiveSessionIf session = driver.createSession();

    try {

      // open a connection to the database
      session.connect("Administrator", "1983818", "testdb");

      // begin the transaction
      session.begin();

      // get a handle to the database
      XhiveDatabaseIf unitedNationsDb = session.getDatabase();

      // get a handle to the root library
      XhiveLibraryIf rootLibrary = unitedNationsDb.getRoot();

      // get/create the "UN Charter" library
      // load the sample documents

      // Create a query (find all the short chapter titles)
      String theQuery = "//Fact";

      // Execute the query (place the results in the new document)
      System.out.println("#running query:\n" + theQuery);
      IterableIterator<? extends XhiveXQueryValueIf> result = rootLibrary.executeXQuery(theQuery);

      // Process the results
      while (result.hasNext()) {
        // Get the next value from the result sequence
        XhiveXQueryValueIf value = result.next();

        // Print this value
        System.out.println(value.toString());
      }

      session.commit();

    } catch (Exception e) {

      System.err.println("XQuery sample failed: ");
      e.printStackTrace();

    } finally {

      // disconnect and remove the session
      if (session.isOpen()) {
        session.rollback();
      }
      if (session.isConnected()) {
        session.disconnect();
      }

      driver.close();
    }
  }
}

