package DB_XML;

import java.awt.Color;
import java.io.File;
import java.util.Iterator;

import org.w3c.dom.Document;
import org.w3c.dom.ls.LSParser;

import Interface_XWeb.Xwebapp;

import com.xhive.XhiveDriverFactory;
import com.xhive.core.interfaces.XhiveDatabaseIf;
import com.xhive.core.interfaces.XhiveDriverIf;
import com.xhive.core.interfaces.XhiveSessionIf;
import com.xhive.dom.interfaces.XhiveDocumentIf;
import com.xhive.dom.interfaces.XhiveLibraryIf;
import com.xhive.dom.interfaces.XhiveNodeIf;
import com.xhive.error.XhiveException;
import com.xhive.query.interfaces.XhiveXQueryValueIf;
import com.xhive.util.interfaces.IterableIterator;

/**
 * Classe herite de la Classe Abstrait DataBase,permet de gerer la connection
 * avec une base de donnes XHive
 * 
 */

public class xhive extends DataBase
{
	XhiveSessionIf session;

	public xhive(){
		super();
	}

	public boolean connection()
	{
		boolean res = false;
		try
		{
			// creation d'une session
			XhiveDriverIf driver = XhiveDriverFactory.getDriver(this.host);
			driver.init(1024);
			session = driver.createSession();
			// Ouverture de la connection
			session.connect(this.user, this.pass, this.dbName);
			session.begin();
			if (session.isConnected())
			{
				res = true;
			}
		} catch (Exception e)
		{
			System.out.println(e.getMessage());
			e.printStackTrace();
			//session.getDriver().close();
			res=false;
		}
		return res;
	}

	public boolean deconnection()
	{
		boolean res = false;
		try
		{
			session.getDriver().close();
			res = true;
		} catch (Exception e)
		{
			System.out.println(e.getMessage());
		}
		return res;
	}

	public long addFile(String path, String filename)
	{
        long t1;
        long t2;
        t1 = System.currentTimeMillis();
		// creation d'une session
		XhiveDriverIf driver = XhiveDriverFactory.getDriver(host);
		if (!driver.isInitialized())
			driver.init(1024);
		XhiveSessionIf session = driver.createSession();
		try
		{

			// Ouverture de la connection
			session.connect(user, pass, dbName);
			if (!session.isConnected())
			{
				return -1;
			}
			session.begin();
			XhiveDatabaseIf database = session.getDatabase();
			System.out.println("******************" + database.getName()
					+ "******************");
			XhiveLibraryIf lib = database.getRoot();
			// Ouverture du fichier
			// Document fdoc = lib.parseDocument(new File(path).toURL(),
			// XhiveLibraryIf.PARSER_NO_VALIDATION);
			LSParser builder = lib.createLSParser();
			Document fdoc = builder.parseURI(new File(path).toURL().toString());
			System.out.println("******************" + fdoc.getNamespaceURI()
					+ "******************");
			// Ajout du fichier dans la base
			if (lib.nameExists(filename))
			{
				Iterator iter = lib.getChildren();
				while (iter.hasNext())
				{
					XhiveNodeIf node = (XhiveNodeIf) iter.next();
					if (node instanceof XhiveDocumentIf)
					{
						XhiveDocumentIf doc = (XhiveDocumentIf) node;
						System.out.println("Suppression de " + doc.getName());
						lib.removeChild(node);
					}
				}
			}
			lib.appendChild(fdoc);

			((XhiveDocumentIf) fdoc).setName(filename);
			session.commit();
			System.out.println("Load succeeded");
			System.out.println("=====================================\n");
            t2 = System.currentTimeMillis();
			return t2-t1;
		} catch (Exception e)
		{
			System.out.println(e.getMessage());
			session.rollback();
			return -1;
		}
	};

	public long executeReq(String Req){
		
		XhiveDriverIf driver = XhiveDriverFactory.getDriver(host);
		if (!driver.isInitialized()) driver.init(1024);
		XhiveSessionIf session = driver.createSession();

		long t1, t2;
		try	{
			// Ouverture de la session
			session.connect(user, pass, dbName);
			if (!session.isConnected())
			return -1;

			// dbut de la transaction
			session.begin();

			XhiveDatabaseIf database = session.getDatabase();
			XhiveLibraryIf lib = database.getRoot();
			// Execution de la requte
			t1 = System.currentTimeMillis();
			Iterator result = lib.executeXQuery(Req);
			
			//if (result== null)	return -1;
			
			// Affichage du rsultat
			
			while (result.hasNext()) {
				//System.out.println(result.next().toString()); 
				result.next();
			}
			t2 = System.currentTimeMillis();
			
			
			// Commit
			session.commit();
			return t2 - t1;
			
			
		} catch (Exception e){
			System.out.println("ConnectDatabase sample failed: ");
			System.out.println(e.getMessage());
			return -1;
		} finally{
			// Deonnection
			if (session.isOpen()){
				session.rollback();
			}
			if (session.isConnected()){
				session.disconnect();
			}
			driver.close();
		}
	}

}
